/*
    buzzer.c
    Copyright (C) 2011
    Authors: Arun I, Hari Prasad Gokul R 
    email: theroarofthedragon@gmail.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
*/

#include <avr/io.h>

uint8_t bcd2sevensegment(uint8_t bcd);

int main()
{
	uint8_t switches;
	uint8_t i;

	DDRD=0x00;	//Port D configured as input for the switches
	DDRB=0xff; 	//Port B configured as output for seven segment display
	PORTB=0x00;	//Port B reset

	while (1) {
		switches=PIND;
		if (switches!=0x00) {
			for (i=0;i<8;i++) {
				if (switches & 0x01) {
					break;
				}
				switches=switches>>1;
			}
			PORTB=bcd2sevensegment(i+1);	//For seven segment display
			break;
		}
	};
	return(0);
}

uint8_t bcd2sevensegment(uint8_t bcd)
{
	//function converts bcd (decimal number) to equivalent seven segment code
	//MSB is always set and corresponds to the on state of the piezo buzzer
	switch (bcd) {
		case 0:
			return(0xfe);
		case 1:
			return(0xb0);
		case 2:
			return(0xed);
		case 3:
			return(0xf9);
		case 4:
			return(0xb3);
		case 5:
			return(0xdb);
		case 6:
			return(0xdf);
		case 7:
			return(0xf0);
		case 8:
			return(0xff);
		case 9:
			return(0xfb);
		default:
			return(0x00);
	}
}
